#!/usr/bin/perl
#
# convtable.pl - Generate convtable.h from twoway.txt/zen2han.txt/han2zen.txt
#
# Copyright (C) 2003 Yukihiro Nakai <nakai@gnome.gr.jp>
#

open(HEADER, "| iconv -f EUC-JP -t UTF-8 > convtable.h") || die "Can't open\n";
select(HEADER);
print<<EOF;
#ifndef _CONVTABLE_H
#define _CONVTABLE_H

#include <glib.h>

typedef struct _strpair {
  const gchar* lstr;
  const gchar* rstr;
} strpair;

strpair twoway_table[] = {
EOF
open(TWOWAY, "twoway.txt") || die "Can't open\n";
while(<TWOWAY>) {
  next if(/^###/); # Comment cutter
  s/\n$//;
  ($zen, $han) = split(/\t/);
  $han = "\\\\" if ( $han eq "\\" );
  $han = "\\\"" if ( $han eq "\"" );

  print "  { \"$zen\", \"$han\" },\n";
}
close(TWOWAY);
print<<EOF;
};

strpair zen2han_table[] = {
EOF
open(ZEN2HAN, "zen2han.txt") || die "Can't open\n";
while(<ZEN2HAN>) {
  next if(/^###/); # Comment cutter
  s/\n$//;
  ($zen, $han) = split(/\t/);
  $han = "\\\\" if ( $han eq "\\" );
  $han = "\\\"" if ( $han eq "\"" );

  print "  { \"$zen\", \"$han\" },\n";
}
close(ZEN2HAN);
print<<EOF;
};

strpair han2zen_table[] = {
EOF
open(HAN2ZEN, "han2zen.txt") || die "Can't open\n";
while(<HAN2ZEN>) {
  next if(/^###/); # Comment cutter
  s/\n$//;
  ($zen, $han) = split(/\t/);
  $han = "\\\\" if ( $han eq "\\" );
  $han = "\\\"" if ( $han eq "\"" );

  print "  { \"$zen\", \"$han\" },\n";
}
close(HAN2ZEN);
print<<EOF;
};

#endif /* _CONVTABLE_H */
EOF
close(HEADER);
